=== doc-translated/pt_BR/CMakeLists.txt ===
kde4_create_handbook( index.docbook INSTALL_DESTINATION ${HTML_INSTALL_DIR}/pt_BR/ SUBDIR digikam )
